<?php
//===============inc/smtp_mail.class.php==============
class smtp_mail{
	var $fp=false;
	var $lastmsg="";
	var $authMode=false;
	var $authLastLine;
	var $debugMode=false;
	var $authLoginName;
	var $authLoginPassword;

	function read_line(){
		$ret=false;
		$line=fgets($this->fp,1024);
		if($this->debugMode){
			echo "RESPONSE: $line <br/>";
			flush();
		}
		if(ereg("^([0-9]+).(.*)$",$line,$data)){
			$recv_code=$data[1];
			$recv_msg=$data[2];
			$ret=array($recv_code,$recv_msg);
		}
		return $ret;
	}

	function dialogue($code,$cmd,$response=false){
		$ret=true;
		if($this->debugMode){
			echo "CWD: $cmd <br/>";
			flush();
		}
		fwrite($this->fp,$cmd."\r\n");
		$line=$this->read_line();
		if($line==false){
			$ret=false;
			$this->lastmsg="";
		}
		else{
			$this->lastmsg="$line[0] $line[1]";
			if($line[0]!=$code){
				$ret=false;
				return $ret;
			}
			if($response!==false){
				$response.="\r\n";
				while($line[1]!=$response){
					$line=$this->read_line();
//					$this->lastmsg.="<br/>$line[0] $line[1]";
					if($line[0]!=$code){
						$ret=false;
						return $ret;
					}
				}
			}
			return $ret;
		}
	}

	function error_message(){
		echo "SMTP Protocol failure (".$this->lastmsg.").<br/>";
		flush();
	}

	function crlf_encode($data){
		$data.="\n";
		$data=str_replace("\n","\r\n",str_replace("\r","",$data));
		$data=str_replace("\n.\r\n","\n. \r\n",$data);
		return $data;
	}

	function handle_email($from,$to,$data){
		$rcpts=explode(",",$to);
		$err=false;
	    if(!$this->dialogue(250,"HELO")){
			$err=true;
		}
	    if(!$this->dialogue(250,"EHLO",$this->authLastLine)){
			$err=true;
		}
		if($this->authMode){
			if(!$this->dialogue(334,"AUTH LOGIN")) {
				$err=true;
			}
			if(!$this->dialogue(334,base64_encode($this->authLoginName))){
				$err=true;
			}
			if(!$this->dialogue(235,base64_encode($this->authLoginPassword))){
				$err=true;
			}
		}
		if(!$this->dialogue(250,"MAIL FROM: $from") ){
			$err=true;
		}
		for($i=0;!$err&&$i<count($rcpts);$i++){
			if(!$this->dialogue(250,"RCPT TO: $rcpts[$i]")){
				$err=true;
			}
		}
		if($err||!$this->dialogue(354,"DATA")||!fwrite($this->fp,$data)||!$this->dialogue(250,"\r\n.")||!$this->dialogue(221,"QUIT") ){
			$err=true;
		}
		if($err){
			$this->error_message();
		}
		return !$err;
	}

	function connect($hostname){
		if($this->debugMode){
			echo "CONNECTING $hostname ...";
		}
		$ret=false;
		$this->fp=fsockopen($hostname,25);
		if($this->fp){
			$ret=true;
			if($this->debugMode){
				echo "Succeed!<br/>";
				flush();
			}
		}
		else{
			if($this->debugMode){
				echo "Failed!<br/>";
				flush();
			}
		}
		return $ret;
	}

	function send_email($hostname,$from,$to,$data,$crlf_encode=1){
		if(!$this->connect($hostname)){
			echo "cannot open connection!<br/>\n";
			flush();
			return false;
		}
		$line=$this->read_line();
		$ret=false;
		if($line&&$line[0]=="220"){
			if($crlf_encode){
				$data=$this->crlf_encode($data);
			}
			$ret=$this->handle_email($from,$to,$data);
		}
		else{
			$this->error_message();
		}
		fclose($this->fp);
		return $ret;
	}
};
?>